Unit SProcUnit;

Interface

Function  ContinueService(ServiceName:String):Boolean;
Function  PauseService(ServiceName:String):Boolean;
Function  StopService(ServiceName:String):Boolean;

Implementation

Uses WinSvc, Windows;

Function  ContinueService(ServiceName:String):Boolean;
Var hSC_MANAGER : SC_HANDLE;
    hService : SC_HANDLE;
    SvcInfo : _SERVICE_STATUS;
begin
Result:=False;
hSC_MANAGER:=OpenSCManager(Nil,Nil,SC_MANAGER_CONNECT);
If hSC_MANAGER > 0 Then
   begin
   hService:=OpenService(hSC_MANAGER,PAnsiChar(ServiceName),SERVICE_PAUSE_CONTINUE);
   If hService > 0 Then
      begin
      Result:=ControlService(hService,SERVICE_CONTROL_CONTINUE,SvcInfo);
      CloseServiceHandle(hService);
      end;
   CloseServicehandle(hSC_MANAGER);
   end
end;

Function  PauseService(ServiceName:String):Boolean;
Var hSC_MANAGER : SC_HANDLE;
    hService : SC_HANDLE;
    SvcInfo : _SERVICE_STATUS;
begin
Result:=False;
hSC_MANAGER:=OpenSCManager(Nil,Nil,SC_MANAGER_CONNECT);
If hSC_MANAGER > 0 Then
   begin
   hService:=OpenService(hSC_MANAGER,PAnsiChar(ServiceName),SERVICE_PAUSE_CONTINUE);
   If hService > 0 Then
      begin
      Result:=ControlService(hService,SERVICE_CONTROL_PAUSE,SvcInfo);
      CloseServiceHandle(hService);
      end;
   CloseServicehandle(hSC_MANAGER);
   end
end;

Function  StopService(ServiceName:String):Boolean;
Var hSC_MANAGER : SC_HANDLE;
    hService : SC_HANDLE;
    SvcInfo : _SERVICE_STATUS;
begin
Result:=False;
hSC_MANAGER:=OpenSCManager(Nil,Nil,SC_MANAGER_CONNECT);
If hSC_MANAGER > 0 Then
   begin
   hService:=OpenService(hSC_MANAGER,PAnsiChar(ServiceName),SERVICE_STOP Or STANDARD_RIGHTS_REQUIRED);
   If hService > 0 Then
      begin
      Result:=ControlService(hService,SERVICE_CONTROL_STOP,SvcInfo);
      CloseServiceHandle(hService);
      end;
   CloseServiceHandle(hSC_MANAGER);
   end
end;

end.
 