Unit HandlesImport;

Interface

Uses Windows;

Type THandleRecord = Record
                     Handle          : DWORD;
                     HandleType      : String;
                     HandleName      : String;
                     References      : DWORD;
                     Access          : Cardinal;
                     HandleTypeNum   : Cardinal;
                     OriginalTypeNum : Cardinal;
                     pObject         : Pointer;
                     CreatorPID      : Cardinal;
                     end;
     PHandleRecord = ^THandleRecord;
                     
     TEnumHandlesProc = Function (AObject:THandleRecord):Boolean; StdCall;


Procedure EnumKernelObjects(EnumHandlesProc:TEnumHandlesProc; PID:Cardinal); StdCall;
Function ConvertRegistryName(S:String):String; StdCall;
Function UpravNazev(Nazev:String):String; StdCall;

Implementation

Type
  TEnumKernelObjects   = Procedure (EnumHandlesProc:TEnumHandlesProc; PID:Cardinal); StdCall;
  TConvertRegistryName = Function (S:String):String; StdCall;
  TUpravNazev          = Function (Nazev:String):String; StdCall;

Var
  _EnumKernelObjects : TEnumKernelObjects;
  _UpravNazev : TUpravNazev;
  _ConvertRegistryName : TConvertRegistryName;

Procedure EnumKernelObjects(EnumHandlesProc:TEnumHandlesProc; PID:Cardinal); StdCall;
begin
_EnumKernelObjects(EnumHandlesProc,PID);
end;

Function ConvertRegistryName(S:String):String; StdCall;
begin
Result:=_ConvertRegistryName(S);
end;

Function UpravNazev(Nazev:String):String; StdCall;
begin
Result:=_UpravNazev(Nazev);
end;

Var hMod : Cardinal;
Initialization
hMod:=LoadLibrary('Handles.dll');
If hMod > 0 Then
   begin
   _EnumKernelObjects:=GetProcAddress(hMod,'EnumKernelObjects');
   _UpravNazev:=GetProcAddress(hMod,'UpravNazev');
   _ConvertRegistryName:=GetProcAddress(hMod,'ConvertRegistryName');
   end
Else MessageBox(0,'Knihovna HANDLES.DLL nenalezena!','Soubor nenalezen!',MB_OK Or MB_ICONERROR);
End.
