Unit ModuleOperationImport;

Interface

Uses Windows, Classes, TlHelp32;

Function  RemoveRemoteModule(PID:Cardinal; ModuleName:PChar):Boolean;
Function  InjectModule(PID:Cardinal; ModuleName:PChar):THandle;
Function  GetProcList(ModuleName:String):TStringList;
Function  GetRemoteModuleHandle(PID:Cardinal; ModuleName:PChar):HMODULE;
Procedure OkTerminateProcess(PID:Cardinal);
Function  GetImportListByModuleName(ModuleName:String):TStringList;
Function  GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList;
Function  ModuleSearchInit(PID:Cardinal):Cardinal;
Function  ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
Function  ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
Procedure ModuleSearchDestroy(hSearch:THandle);

Implementation

Type
  TRemoveRemoteModule = Function (PID:Cardinal; ModuleName:PChar):Boolean;        StdCall;
  TInjectModule = Function (PID:Cardinal; ModuleName:PChar):THandle;              StdCall;
  TGetProcList = Function (ModuleName:String):TStringList;                        StdCall;
  TGetRemoteModuleHandle = Function (PID:Cardinal; ModuleName:PChar):HMODULE;     StdCall;
  TOkTerminateProcess = Procedure (PID:Cardinal);                                 StdCall;
  TGetImportListByModuleName = Function (ModuleName:String):TStringList;          StdCall;
  TGetImportListByModuleBaseAddr = Function  (Base,PID:Cardinal):TStringList;     StdCall;
  TModuleSearchInit  = Function (PID:Cardinal):Cardinal;                          StdCall;
  TModuleSearchFirst = Function (hSearch:THandle; Var ME:ModuleEntry32):Boolean;  StdCall;
  TModuleSearchNext  = Function (hSearch:THandle; Var ME:ModuleEntry32):Boolean;  StdCall;
  TModuleSearchDestroy = Procedure (hSearch:THandle);                             StdCall;



Var
    _RemoveRemoteModule            : TRemoveRemoteModule;
    _InjectModule                  : TInjectModule;
    _GetProcList                   : TGetProcList;
    _GetRemoteModuleHandle         : TGetRemoteModuleHandle;
    _OkTerminateProcess            : TOkTerminateProcess;
    _GetImportListByModuleName     : TGetImportListByModuleName;
    _GetImportListByModuleBaseAddr : TGetImportListByModuleBaseAddr;
    _ModuleSearchInit              : TModuleSearchInit;
    _ModuleSearchFirst             : TModuleSearchFirst;
    _ModuleSearchNext              : TModuleSearchNext;
    _ModuleSearchDestroy           : TModuleSearchDestroy;

Function  RemoveRemoteModule(PID:Cardinal; ModuleName:PChar):Boolean;
begin
Result:=_RemoveRemoteModule(PID,ModuleName);
end;

Function  InjectModule(PID:Cardinal; ModuleName:PChar):THandle;
begin
Result:=_InjectModule(PID,ModuleName);
end;

Function  GetProcList(ModuleName:String):TStringList;
begin
Result:=_GetProcList(ModuleName);
end;

Function  GetRemoteModuleHandle(PID:Cardinal; ModuleName:PChar):HMODULE;
begin
Result:=_GetRemoteModuleHandle(PID,ModuleName);
end;

Procedure OkTerminateProcess(PID:Cardinal);
begin
_OkTerminateProcess(PID);
end;

Function  GetImportListByModuleName(ModuleName:String):TStringList;
begin
Result:=_GetImportListByModuleName(ModuleName);
end;

Function  GetImportListByModuleBaseAddr(Base,PID:Cardinal):TStringList;
begin
Result:=_GetImportListByModuleBaseAddr(Base,PID);
end;

Function  ModuleSearchInit(PID:Cardinal):Cardinal;
begin
Result:=_ModuleSearchInit(PID);
end;

Function  ModuleSearchFirst(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
begin
Result:=_ModuleSearchFirst(hSearch,ME);
end;

Function  ModuleSearchNext(hSearch:THandle; Var ME:ModuleEntry32):Boolean;
begin
Result:=_ModuleSearchNext(hSearch,ME);
end;

Procedure ModuleSearchDestroy(hSearch:THandle);
begin
_ModuleSearchDestroy(hSearch);
end;

Var hLib : THandle;
Initialization
hLib:=LoadLibrary('ModuleOperation.dll');
If hLib > 0 Then
   begin
   _RemoveRemoteModule:=GetProcAddress(hLib,'RemoveRemoteModule');
   _InjectModule:=GetProcAddress(hLib,'InjectModule');
   _GetProcList:=GetProcAddress(hLib,'GetProcList');
   _GetRemoteModuleHandle:=GetProcAddress(hLib,'GetRemoteModuleHandle');
   _OkTerminateProcess:=GetProcAddress(hLib,'OkTerminateProcess');
   _GetImportListByModuleName:=GetProcAddress(hLib,'GetImportListByModuleName');
   _GetImportListByModuleBaseAddr:=GetProcAddress(hLib,'GetImportListByModuleBaseAddr');
   _ModuleSearchInit:=GetProcAddress(hLib,'ModuleSearchInit');
   _ModuleSearchFirst:=GetProcAddress(hLib,'ModuleSearchFirst');
   _ModuleSearchNext:=GetProcAddress(hLib,'ModuleSearchNext');
   _ModuleSearchDestroy:=GetProcAddress(hLib,'ModuleSearchDestroy');
   end
Else MessageBox(0,'Nelze najt soubor MODULEOPERATION.DLL. Chybjc soubor vrazn omez funkce programu!','Error',MB_OK Or MB_ICONERROR);
End.
