Unit ssdtImport;

Interface

Uses Windows;

Type
  TSSDTRoutine = Function (DescriptorBase, DispatchBase, FunctionCount, AktFunc, AktFuncAddr : Cardinal):Boolean; StdCall;

Function GetSSDT(SSDTFunction:TSSDTRoutine):Boolean; StdCall;

Implementation

Type
    TGetSSDT = Function (SSDTFunction:TSSDTRoutine):Boolean; StdCall;

Var _GetSSDT : TGetSSDT;

Function GetSSDT(SSDTFunction:TSSDTRoutine):Boolean; StdCall;
begin
Result:=_GetSSDT(SSDTFunction);
end;

Var hMod : Cardinal;
Initialization
hMod:=LoadLibrary('ssdt.dll');
If hMod > 0 Then
   begin
   _GetSSDT:=GetProcAddress(hMod,'GetSSDT');
   end
Else MessageBox(0,'Nelze nalzt soubor ssdt.dll','Soubor nenalezen!',MB_OK Or MB_ICONERROR);

Finalization
hMod:=GetModuleHandle('ssdt.dll');
If hMod > 0 Then
   FreeLibrary(hMod);
End.
