Library Drivers;

{$R *.RES}

Uses
  ShareMem,
  Windows,
  DriverManager In 'DriverManager.pas';

Var DrvMgr : TDriverManager;

Function InstallDriver(FileName:String; DriverName:String):Cardinal; StdCall;
begin
Result:=DrvMgr.Install(FileName,Drivername);
end;

Function UnInstallDriver(DriverName:String):Cardinal; StdCall;
begin
Result:=DrvMgr.UnInstall(DriverName);
end;

Function LoadDriver(DriverName:String):Cardinal; StdCall;
begin
Result:=DrvMgr.Start(DriverName);
end;

Function UnLoadDriver(DriverName:String):Cardinal; StdCall;
begin
Result:=DrvMgr.Stop(DriverName);
end;

Exports
  InstallDriver,
  UnInstallDriver,
  LoadDriver,
  UnLoadDriver;

Procedure DLLMain(dwReason:Cardinal);
begin
Case dwReason Of
     DLL_PROCESS_ATTACH : DrvMgr:=TDriverManager.Create;
     DLL_PROCESS_DETACH : DrvMgr.Free;
     end;
end;

begin
DisableThreadLibraryCalls(HInstance);
DLLProc:=@DLLMain;
DLLMain(DLL_PROCESS_ATTACH);
End.
