Unit FMMain;

Interface

Uses Windows;

Const
      // Typ handlu
      HANDLE_TYPE_FILE     = 1;
      HANDLE_TYPE_MAP_FILE = 2;
      HANDLE_TYPE_MEMORY   = 3;
      HANDLE_KERNEL_MEMORY = 4;

Type
     TBuffer = Array [0..1] Of Byte;
     PBuffer = ^TBuffer;


Function GetObjectContent(hObject:THandle; ObjectType:Cardinal; TargetPID:Cardinal; Buffer : PBuffer; Var Size:Cardinal):Boolean; StdCall;

Implementation

Uses SysUtils, ProceduresImport;

Function GetObjectContent(hObject:THandle; ObjectType:Cardinal; TargetPID:Cardinal; Buffer : PBuffer; Var Size:Cardinal):Boolean; StdCall;
Var hProcess : THandle;
    hObject2 : THandle;
    ObjectSize : Int64;
    Pom        : Cardinal;
    Read       : Cardinal;
begin
Pom:=NO_ERROR;
Result:=False;
If (ObjectType = HANDLE_TYPE_FILE) Or
   (ObjectType = HANDLE_TYPE_MAP_FILE) Then
   begin
   hProcess:=OpenProcess(PROCESS_DUP_HANDLE,False,TargetPID);
   If hProcess = 0 Then
      begin
      SetLastError(GetLastError);
      Exit;
      end;
   If Not DuplicateHandle(hProcess,hObject,GetCurrentProcess,@hObject2,GENERIC_READ,False,DUPLICATE_SAME_ACCESS) Then
      begin
      SetLastError(GetLastError);
      CloseHandle(hProcess);
      Exit;
      end;
   Case ObjectType Of
        HANDLE_TYPE_FILE : begin
                           ObjectSize:=GetFileSize(hObject2,Nil);
                           Pom:=GetLastError;
                           If ObjectSize = 0 Then
                              begin
                              CloseHandle(hProcess);
                              CloseHandle(hObject2);
                              SetLastError(Pom);
                              Exit;
                              end;
                           If (Buffer = Nil) Or (Size < ObjectSize) Then
                              begin
                              CloseHandle(hObject2);
                              CloseHandle(hProcess);
                              Size:=ObjectSize;
                              SetLastError(ERROR_MORE_DATA);
                              Exit;
                              end
                           Else Size:=ObjectSize;
                           SetFilePointer(hObject2,0,Nil,FILE_BEGIN);
                           Pom:=GetLastError;
                           If Pom <> NO_ERROR Then
                              begin
                              CloseHandle(hObject2);
                              CloseHandle(hProcess);
                              SetLastError(Pom);
                              Exit;
                              end;
                           ZeroMemory(Buffer,Size);
                           Result:=ReadFile(hObject2,Buffer^,Size,Read,Nil);
                           Pom:=GetLastError;
                           CloseHandle(hObject2);
                           CloseHandle(hProcess);
                           end;
        HANDLE_TYPE_MAP_FILE : begin
                               end;
        end;
   end
Else If (ObjectType = HANDLE_TYPE_MEMORY) Then
        begin
        If (Buffer = Nil) Or (hObject > $80000000) Then
           begin
           SetLastError(ERROR_INVALID_PARAMETER);
           Exit;
           end;
        hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_READ,False,TargetPID);
        If hProcess = 0 Then
           begin
           SetLastError(GetLastError);
           Exit;
           end;
        Result:=ReadProcessMemory(hProcess,Pointer(hObject),Buffer,Size,Size);
        Pom:=GetLastError;
        CloseHandle(hProcess);
        end;
SetLastError(Pom);
end;

End.
