Unit PProcImport;

Interface

Uses Windows, Win95Functions, TlHelp32;

Type
    TMemoryCallBack = Function (Mem:_MEMORY_BASIC_INFORMATION):Boolean; StdCall;
    TDebugProcedure = Function (Event: _DEBUG_EVENT):Boolean; StdCall;

Function  ProcessTimes(PID:Cardinal; Var Created,Exited:TDateTime; Var Kernel,User:Int64):Boolean;  StdCall;
Procedure ZaregistrujJakoSluzbu(PID:Cardinal); StdCall;
Procedure Odregistruj(PID:Cardinal);           StdCall;
Function  LzeCistPamet(PID:Cardinal):Boolean;        StdCall;
Function  NactiPametProcesu(PID:Cardinal; Odkud,Kam:Pointer; Pocet:Cardinal; Var Readed:Cardinal):Cardinal; StdCall;
Function  DejPocetHandlu(PID:Cardinal):Int64; StdCall;
Function  DejPocetGDIHandlu(PID:Cardinal):Int64; StdCall;
Function  DejPocetUserHandlu(PID:Cardinal):Int64; StdCall;
Function  DejAlokovanouPamet(PID:Cardinal):Int64; StdCall;
Function  DejReservovanouPamet(PID:Cardinal):Int64; StdCall;
Function  DejSouborZPID(PID:Cardinal):String; StdCall;
Function  DejRodiceVlakna(TID:Cardinal):Cardinal; StdCall;
Function  DejSouborZTID(TID:Cardinal):String; StdCall;
Procedure SuspendProcess(PID:Cardinal); StdCall;
Procedure ResumeProcess(PID:Cardinal); StdCall;
Procedure KillProcess(PID:Cardinal); StdCall;
Procedure RunProcess(ProcessFileName:String); StdCall;
Function  DejSouborProcesu(APID:Cardinal):String; StdCall;
Function UniversalProcessSearchInit:THandle;                                          StdCall;
Function UniversalProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean; StdCall;
Function UniversalProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;  StdCall;                                       StdCall;
Procedure UniversalProcessSearchDestroy(hSearch:THandle); StdCall;
Procedure DejOblastiPametiProcesu(PID:Cardinal; CallBack:TMemoryCallBack);   StdCall;
Function  StartDebuggingProcess(PID:Cardinal; ADebugProc:TDebugProcedure):Boolean; StdCall;
Function  StopDebuggingProcess(PID:Cardinal):Boolean; StdCall;

Implementation

Type
    TShowWindowProcesu = Procedure (PID:Cardinal; Msg:Cardinal); StdCall;
    TPosliZpravuProcesu = Procedure (PID:Cardinal; Msg:Cardinal; wParam:WPARAM; lParam:LPARAM); StdCall;
    TProcessTimes = Function (PID:Cardinal; Var Created,Exited:TDateTime; Var Kernel,User:Int64):Boolean; StdCall;
    TZaregistrujJakoSluzbu = Procedure (PID:Cardinal); StdCall;
    TOdregistruj = Procedure (PID:Cardinal);           StdCall;
    TSkryjProces = Procedure (PID:Cardinal; WinNT:Boolean); StdCall;
    TOdkryjProces = Procedure (PID:Cardinal; WinNT:Boolean); StdCall;
    TLzeCistPamet = Function  (PID:Cardinal):Boolean; StdCall;
    TNactiPametProcesu = Function  (PID:Cardinal; Odkud,Kam:Pointer; Pocet:Cardinal; Var Readed:Cardinal):Cardinal; StdCall;
    TDejPocetHandlu = Function  (PID:Cardinal):Int64; StdCall;
    TDejPocetGDIHandlu = Function  (PID:Cardinal):Int64; StdCall;
    TDejPocetUserHandlu = Function  (PID:Cardinal):Int64; StdCall;
    TDejAlokovanouPamet = Function  (PID:Cardinal):Int64; StdCall;
    TDejReservovanouPamet = Function (PID:Cardinal):Int64; StdCall;
    TDejSouborZPID = Function (PID:Cardinal):String; StdCall;
    TDejRodiceVlakna = Function (TID:Cardinal):Cardinal; StdCall;
    TDejSouborzTID = Function (TID:Cardinal):String;  StdCall;
    TSuspendProcess = Procedure (PID:Cardinal); StdCall;
    TResumeProcess = Procedure (PID:Cardinal); StdCall;
    TKillProcess = Procedure (PID:Cardinal); StdCall;
    TRunProcess = Procedure (ProcessFileName:String); StdCall;
    TDejSouborProcesu = Function (APID:Cardinal):String; StdCall;
    TWin95GetProcessHandleTable = Function (PID:Cardinal):PProcessHandleTable; StdCall;
    TProcessSearchInit =  Function :THandle;                                          StdCall;
    TProcessSearchFirst = Function (hSearch:THandle; Var PE:ProcessEntry32):Boolean; StdCall;
    TProcessSearchNext = Function (hSearch:THandle; Var PE:ProcessEntry32):Boolean;  StdCall;
    TDejOblastiPametiProcesu = Procedure (PID:Cardinal; CallBack:TMemoryCallBack);   StdCall;
    TProcessSearchDestroy = Procedure (hSearch:THandle); StdCall;
    TStartDebuggingProcess = Function (PID:Cardinal; ADebugProc:TDebugProcedure):Boolean; StdCall;
    TStopDebuggingProcess = Function (PID:Cardinal):Boolean; StdCall;




Var
    _ShowWindowProcesu : TShowWindowProcesu;
    _PosliZpravuProcesu : TPosliZpravuProcesu;
    _ProcessTimes : TProcessTimes;
    _ZaregistrujJakoSluzbu : TZaregistrujJakoSluzbu;
    _Odregistruj : TOdregistruj;
    _SkryjProces : TSkryjProces;
    _OdkryjProces : TOdkryjProces;
    _LzeCistPamet : TLzeCistPamet;
    _NactiPametProcesu : TNactiPametProcesu;
    _DejPocetHandlu    : TDejPocetHandlu;
    _DejPocetGDIHandlu : TDejPocetGDIHandlu;
    _DejPocetUserHandlu : TDejPocetUserHandlu;
    _DejReservovanouPamet : TDejReservovanouPamet;
    _DejAlokovanouPamet : TDejAlokovanouPamet;
    _DejSouborZPID : TDejSouborZPID;
    _DejRodiceVlakna : TDejRodiceVlakna;
    _DejSouborZTID : TDejSouborZTID;
    _SuspendProcess : TSuspendProcess;
    _ResumeProcess : TResumeProcess;
    _KillProcess : TKillProcess;
    _RunProcess : TRunProcess;
    _DejSouborProcesu : TDejSouborProcesu;
    _Win95GetProcessHandleTable : TWin95GetProcessHandleTable;
    _ProcessSearchNext : TProcessSearchNext;
    _ProcessSearchFirst : TProcessSearchFirst;
    _ProcessSearchInit : TProcessSearchInit;
    _ProcessSearchDestroy : TProcessSearchDestroy;
    _DejOblastiPametiProcesu : TDejOblastiPametiProcesu;
    _StartDebuggingProcess : TStartDebuggingProcess;
    _StopDebuggingProcess : TStopDebuggingProcess;

Procedure ShowWindowProcesu(PID:Cardinal; Msg:Cardinal);
begin
_ShowWindowProcesu(PID,Msg);
end;

Procedure PosliZpravuProcesu(PID:Cardinal; Msg:Cardinal; wParam:WPARAM; lParam:LPARAM);
begin
_PosliZpravuProcesu(PID,Msg,wParam,lParam);
end;

Function  ProcessTimes(PID:Cardinal; Var Created,Exited:TDateTime; Var Kernel,User:Int64):Boolean;
begin
Result:=_ProcessTimes(PID,Created,Exited,Kernel,User);
end;

Procedure ZaregistrujJakoSluzbu(PID:Cardinal);
begin
_ZaregistrujJakoSluzbu(PID);
end;

Procedure Odregistruj(PID:Cardinal);
begin
_Odregistruj(PID);
end;

Procedure SkryjProces(PID:Cardinal; WinNT:Boolean);
begin
_SkryjProces(PID,WinNT);
end;

Procedure OdkryjProces(PID:Cardinal; WinNT:Boolean);
begin
_OdkryjProces(PID,WinNT);
end;

Function  LzeCistPamet(PID:Cardinal):Boolean;
begin
Result:=_LzeCistPamet(PID);
end;

Function  NactiPametProcesu(PID:Cardinal; Odkud,Kam:Pointer; Pocet:Cardinal; Var Readed:Cardinal):Cardinal;
begin
Result:=_NactiPametProcesu(PID,Odkud,Kam,Pocet,Readed);
end;

Function  DejPocetHandlu(PID:Cardinal):Int64;
begin
Result:=_DejPocetHandlu(PID);
end;

Function  DejPocetGDIHandlu(PID:Cardinal):Int64;
begin
Result:=_DejPocetGDIHandlu(PID);
end;

Function  DejPocetUserHandlu(PID:Cardinal):Int64;
begin
Result:=_DejPocetUserHandlu(PID);
end;

Function  DejAlokovanouPamet(PID:Cardinal):Int64;
begin
Result:=_DejAlokovanouPamet(PID);
end;

Function  DejReservovanouPamet(PID:Cardinal):Int64;
begin
Result:=_DejReservovanouPamet(PID);
end;

Function  DejSouborZPID(PID:Cardinal):String;
begin
Result:=_DejSouborZPID(PID);
end;

Function  DejRodiceVlakna(TID:Cardinal):Cardinal;
begin
Result:=_DejRodiceVlakna(TID);
end;

Function  DejSouborZTID(TID:Cardinal):String;
begin
Result:=_DejSouborZTID(TID);
end;

Procedure SuspendProcess(PID:Cardinal);
begin
_SuspendProcess(PID);
end;

Procedure ResumeProcess(PID:Cardinal);
begin
_ResumeProcess(PID);
end;

Procedure KillProcess(PID:Cardinal);
begin
_KillProcess(PID);
end;

Procedure RunProcess(ProcessFileName:String);
begin
_RunProcess(ProcessFileName);
end;

Function  DejSouborProcesu(APID:Cardinal):String;
begin
Result:=_DejSouborProcesu(APID);
end;

Function Win9xGetProcessHandleTable(PID:Cardinal):PProcessHandleTable;
begin
Result:=_Win95GetProcessHandleTable(PID);
end;

Function UniversalProcessSearchInit:THandle;                                          StdCall;
begin
Result:=_ProcessSearchInit;
end;

Function UniversalProcessSearchFirst(hSearch:THandle; Var PE:ProcessEntry32):Boolean; StdCall;
begin
Result:=_ProcessSearchFirst(hSearch,PE);
end;

Function UniversalProcessSearchNext(hSearch:THandle; Var PE:ProcessEntry32):Boolean;  StdCall;                                       StdCall;
begin
Result:=_ProcessSearchNext(hSearch,PE);
end;

Procedure UniversalProcessSearchDestroy(hSearch:THandle); StdCall;
begin
_ProcessSearchDestroy(hSearch);
end;

Procedure DejOblastiPametiProcesu(PID:Cardinal; CallBack:TMemoryCallBack);   StdCall;
begin
_DejOblastiPametiProcesu(PID,CallBack);
end;

Function  StartDebuggingProcess(PID:Cardinal; ADebugProc:TDebugProcedure):Boolean; StdCall;
begin
Result:=_StartDebuggingProcess(PID,ADebugProc);
end;

Function  StopDebuggingProcess(PID:Cardinal):Boolean; StdCall;
begin
Result:=_StopDebuggingProcess(PID);
end;

Var hPackage : THandle;
Initialization
hPackage:=LoadLibrary('Proc.dll');
If hPackage > 0 Then
   begin
   _ProcessTimes:=GetProcAddress(hPackage,'ProcessTimes');
   _ZaregistrujJakoSluzbu:=GetProcAddress(hPackage,'ZaregistrujJakoSluzbu');
   _Odregistruj:=GetProcAddress(hPackage,'Odregistruj');
   _SkryjProces:=GetProcAddress(hPackage,'SkryjProces');
   _OdkryjProces:=GetProcAddress(hPackage,'OdkryjProces');
   _LzeCistPamet:=GetProcAddress(hPackage,'LzeCistPamet');
   _NactiPametProcesu:=GetProcAddress(hPackage,'NactiPametProcesu');
   _DejPocetHandlu:=GetProcAddress(hPackage,'DejPocetHandlu');
   _DejPocetGDIHandlu:=GetProcAddress(hPackage,'DejPocetGDIHandlu');
   _DejPocetUserHandlu:=GetProcAddress(hPackage,'DejPocetUserHandlu');
   _DejReservovanouPamet:=GetProcAddress(hPackage,'DejReservovanouPamet');
   _DejAlokovanouPamet:=GetProcAddress(hPackage,'DejAlokovanouPamet');
   _DejSouborZPID:=GetProcAddress(hPackage,'DejSouborZPID');
   _DejRodiceVlakna:=GetProcAddress(hPackage,'DejRodiceVlakna');
   _DejSouborZTID:=GetProcAddress(hPackage,'DejSouborZTID');
   _SuspendProcess:=GetProcAddress(hPackage,'SuspendProcess');
   _ResumeProcess:=GetProcAddress(hPackage,'ResumeProcess');
   _KillProcess:=GetProcAddress(hPackage,'KillProcess');
   _RunProcess:=GetProcAddress(hPackage,'RunProcess');
   _DejSouborProcesu:=GetProcAddress(hPackage,'DejSouborProcesu');
   _Win95GetProcessHandleTable:=GetProcAddress(hPackage,'Win95GetProcessHandleTable');
   _ProcessSearchInit:=GetProcAddress(hPackage,'ProcessSearchInit');
   _ProcessSearchFirst:=GetProcAddress(hPackage,'ProcessSearchFirst');
   _ProcessSearchDestroy:=GetProcAddress(hPackage,'ProcessSearchDestroy');
   _DejOblastiPametiProcesu:=GetProcAddress(hPackage,'DejOblastiPametiProcesu');
   _ProcessSearchNext:=GetProcAddress(hPackage,'ProcessSearchNext');
   _StartDebuggingProcess:=GetProcAddress(hPackage,'StartDebuggingProcess');
   _StopDebuggingProcess:=GetProcAddress(hPackage,'StopDebuggingProcess');
   end
Else begin
     MessageBox(0,'Nelze nalzt knihovnu PROC.DLL. Process Inspector bez n neme bt sputn','DLL nenalezena!',MB_OK Or MB_ICONERROR);
     ExitProcess(1);
     end;

End.
