Unit SProcImport;

Interface

Function  ContinueService(ServiceName:String):Boolean;
Function  PauseService(ServiceName:String):Boolean;
Function  StopService(ServiceName:String):Boolean;

Implementation

Uses Windows;

Type
    TContinueService = Function (A:String):Boolean;
    TStopService = Function (A:String):Boolean;
    TPauseService = Function (A:String):Boolean;

Var _ContinueService : TContinueService;
    _StopService     : TStopService;
    _PauseService    : TPauseService;

Function  ContinueService(ServiceName:String):Boolean;
begin
Result:=_ContinueService(ServiceName);
end;

Function  PauseService(ServiceName:String):Boolean;
begin
Result:=_PauseService(ServiceName);
end;

Function  StopService(ServiceName:String):Boolean;
begin
Result:=_StopService(ServiceName);
end;

Var hMod : HMODULE;
Initialization
hMod:=LoadLibrary('SProc.DLL');
If hMod > 0 Then
   begin
   _StopService:=GetProcAddress(hMod,'StopService');
   _PauseService:=GetProcAddress(hMod,'PauseService');
   _ContinueService:=GetProcAddress(hMod,'ContinueService');
   end
Else MessageBox(0,'Nelze nalst knihovnu SPROC.DLL. Process Inspector nebude moci pracovat se slubami (Services)','DLL knihovna nenalezena!',MB_OK Or MB_ICONERROR);
End.
